//
//	SetTime by pinter@p-squared.com
//

#include	<afxwin.h>
#include	<afxext.h>
#include	<afxpriv.h>
#include	<afxsock.h>
#include	<time.h>
#include	<math.h>
#include	"resource.h"

#define		IDB_QUERY			(WM_USER+1)					// Message ID for Query Button
#define		IDB_SETCLOCK		(WM_USER+2)					// Message ID for Reset Clock Button
#define		IDT_TIMER1			(WM_USER+3)					// Message ID for Timer Event

#define		TIMER_VALUE			(1000)						// Number of milliseconds per frame
#define		FRAME_WIDTH			(500)						// Frame Width in pixels
#define		FRAME_HEIGHT		(300)						// Frame Height in pixels
#define		MAXIMUM_DELTA		(30)						// Maximum Delta in Minutes
#define		TIME_PROTOCOL_PORT	(37)						// Internet standard Port Number

#define		BackGroundColour	(RGB(  0,  0,0))			// Colour value for background
#define		ForeGroundColour	(RGB(255,255,0))			// Colour value for foreground

class		CSetTimeApp : public CWinApp					// Declare the application class
			{
			public:
				virtual	BOOL	InitInstance ();			// Application class Constructor
			};

CSetTimeApp	SetTimeApp;										// Instantiate SetTimeApp

class		CSetTimeWindow : public CFrameWnd				// Declare the main window class
			{
			private:
				BOOL			TCPmode;					// TCP (Stream) Mode flag
				CDC				memDC;						// Memory based Device Context
				CRect			rect;						// Rectangle structure
				CFont			*font;						// Font pointer
				CMenu			*menu,*popupmenu,*tempmenu;	// Menu structures
				CButton			*button1, *button2;			// Buttons for Query & Timeset
				CBitmap			*b1, *b2;					// Button Bitmap structures
				CBitmap			*newMemBitmap;				// Memory DC Bitmap
				CStatusBar		m_wndStatusBar;				// Status Bar

			public:
								CSetTimeWindow		();		// Window class constructor
				virtual			~CSetTimeWindow		();		// Window class destructor
				afx_msg	void	QueryTimebase		();
				afx_msg	void	UpdateSystemClock	();
				afx_msg	void	OnSize				(UINT, int, int);
				afx_msg void	OnTimer				(UINT);
				afx_msg	void	OnPaint				();
				afx_msg	void	OnExit				();
				afx_msg	void	OnAbout				();
				afx_msg	void	OnTCPmode			();
				afx_msg	void	OnRButtonDown		(UINT, CPoint);
				afx_msg	void	OnTimeBase1			();
				afx_msg	void	OnTimeBase2			();
				afx_msg	void	OnTimeBase3			();
				afx_msg	void	OnUpdateStatusBar	(CCmdUI *pCmdUI);
				afx_msg	void	OnUpdateTCP			(CCmdUI *pCmdUI);
				afx_msg	void	OnUpdateUDP			(CCmdUI *pCmdUI);
				afx_msg	void	OnUpdateTICK		(CCmdUI *pCmdUI);
				afx_msg	void	OnUpdateTOCK		(CCmdUI *pCmdUI);
				afx_msg int		OnCreate			(LPCREATESTRUCT lpCreateStruct);
						void	DrawFace			(CDC &dc);

			DECLARE_MESSAGE_MAP	()

			};

class		CMyAsyncSocket : public CAsyncSocket
			{
			public:
				virtual	void	OnConnect	(int nErrorCode);
				virtual	void	OnReceive	(int nErrorCode);
				virtual void	OnClose		(int nErrorCode);
			};

class		Okudagram : public CObject						// In honour of Michael Okuda
			{
			public:
				void	Paint	(CDC &dc, CRect rect);		// Paint the Okudagram on DC
			};

class		CTimeBaseDialog: public CDialog
			{
			private:
				CString			inputString;
			public:
				CTimeBaseDialog (CString initString = NULL, CWnd *pParentWnd = NULL)
								:CDialog (IDD_DIALOG1, pParentWnd)
								{
								inputString = initString;
								}
				virtual	void	OnOK();
				virtual	BOOL	OnInitDialog();
						CString	&GetInputString() { return inputString; }
};

BEGIN_MESSAGE_MAP			(CSetTimeWindow, CFrameWnd)
	ON_WM_CREATE			()
	ON_UPDATE_COMMAND_UI	(ID_VIEW_STATUS_BAR,OnUpdateStatusBar)
	ON_UPDATE_COMMAND_UI	(ID_INDICATOR_TCP,	OnUpdateTCP)
	ON_UPDATE_COMMAND_UI	(ID_INDICATOR_UDP,	OnUpdateUDP)
	ON_UPDATE_COMMAND_UI	(ID_INDICATOR_TICK,	OnUpdateTICK)
	ON_UPDATE_COMMAND_UI	(ID_INDICATOR_TOCK,	OnUpdateTOCK)
	ON_WM_SIZE				()
	ON_WM_TIMER				()
	ON_BN_CLICKED			(IDB_QUERY,			QueryTimebase)
	ON_BN_CLICKED			(IDB_SETCLOCK,		UpdateSystemClock)
	ON_COMMAND				(ID_APP_EXIT,		OnExit)
	ON_COMMAND				(ID_APP_ABOUT,		OnAbout)
	ON_COMMAND				(IDM_TCP_MODE,		OnTCPmode)
	ON_WM_RBUTTONDOWN		()
	ON_COMMAND				(IDM_TIMEBASE1,		OnTimeBase1)
	ON_COMMAND				(IDM_TIMEBASE2,		OnTimeBase2)
	ON_COMMAND				(IDM_TIMEBASE3,		OnTimeBase3)
END_MESSAGE_MAP				()

static		UINT	indicators[] =							// Array of Status Bar indicators
							{
							ID_SEPARATOR,
							ID_INDICATOR_TCP,
							ID_INDICATOR_UDP,
							ID_INDICATOR_TICK,
							ID_INDICATOR_TOCK
							};

static		BOOL			Primary, Secondary;				// Primary or Secondary Timebase
static		BOOL			RunOnce, ExitFlag;				// Run control flags
static		BOOL			UpdateClock;					// Update System Clock flag


static		CTime			Current_time;					// Stores Current System Time
static		WSADATA			WinSockData;					// Stores WinSock implementation data
static		CAsyncSocket	*m_pWinSock;					// Pointer to CMyAsyncSocket object

BOOL		CSetTimeApp::InitInstance ()					// InitInstance called when
			{												// the application first executes

			AfxSocketInit	(&WinSockData);					// Initialize WinSock subsystem

			m_pMainWnd		= new CSetTimeWindow ();		// Instantiate a new Frame Window
			m_pMainWnd->	ShowWindow (m_nCmdShow);		// Ask Windows to show in on screen
			m_pMainWnd->	UpdateWindow ();				// Ask Windows to update the window
			
			SetDialogBkColor();								// Set dialog background color to gray

			SetRegistryKey	("P-Squared");					// Map (or Create) the Registry entry

			AfxGetApp()->	WriteProfileString	("Options",	// Pre-load a valid TimeBase...
												 "TimeBase",// ...either the last value or a default
												 AfxGetApp()->GetProfileString ("Options",
																				"TimeBase",
																				"tick.usno.navy.mil"));
			CString		TimeBase = AfxGetApp()->GetProfileString("Options","TimeBase");
			
			if			(TimeBase == "tick.usno.navy.mil") Primary = TRUE;
			else if		(TimeBase == "tock.usno.navy.mil") Secondary = TRUE;

			if			(m_lpCmdLine[0] != '\0') RunOnce = TRUE;// Run Once and Exit

			UpdateClock	= FALSE;								// Must Query Timebase first

			return		TRUE;
			}

CSetTimeWindow::CSetTimeWindow() :	TCPmode	(TRUE)			// The window class constructor
			{
			CBrush		BackGroundBrush (BackGroundColour);

			const char	*pszWindowClass = AfxRegisterWndClass  (CS_HREDRAW|
																CS_VREDRAW|
																CS_BYTEALIGNCLIENT|
																CS_BYTEALIGNWINDOW|
																CS_SAVEBITS,
																NULL,
																BackGroundBrush,
																AfxGetApp()->LoadIcon (IDI_ICON1));
	
			Create		(pszWindowClass,					// Create the window itself
						"Time Protocol Client",
						WS_OVERLAPPEDWINDOW,
						CRect (0, 0, FRAME_WIDTH, FRAME_HEIGHT),
						NULL,
						MAKEINTRESOURCE(IDR_MENU1));		// *need* to pre-load the menu

			CenterWindow (GetDesktopWindow());
			
			menu		= new CMenu();
			menu->		LoadMenu (MAKEINTRESOURCE(IDR_MENU1));

			popupmenu	= new CMenu();
			popupmenu->	LoadMenu (MAKEINTRESOURCE(IDR_MENU2));

			b1			= new CBitmap(); b1->LoadBitmap (MAKEINTRESOURCE(IDB_BITMAP1));
			b2			= new CBitmap(); b2->LoadBitmap (MAKEINTRESOURCE(IDB_BITMAP2));

			menu->		ModifyMenu (IDM_TIMEBASE1,	MF_BYCOMMAND, IDM_TIMEBASE1, b1);
			menu->		ModifyMenu (IDM_TIMEBASE2,	MF_BYCOMMAND, IDM_TIMEBASE2, b2);

			SetMenu			(menu);

			DrawMenuBar		();

			ShowControlBar	(&m_wndStatusBar, TRUE, FALSE);

			LoadAccelTable	(MAKEINTRESOURCE(IDR_ACCELERATOR1));

			GetClientRect	(rect);							// Get rectangle dimensions

			button1		= new CButton();					// Create a Static Button
			button1->	Create ("Query Current Timebase",
								WS_CHILD|WS_VISIBLE|BS_PUSHBUTTON,
								CRect (rect.left, rect.top, rect.right, rect.top+20),
								this,
								IDB_QUERY);

			button2		= new CButton();					// Create a Static Button
			button2->	Create ("Correct System Clock",
								WS_CHILD|WS_VISIBLE|BS_PUSHBUTTON,
								CRect (rect.left, rect.bottom-40, rect.right, rect.bottom-20),
								this,
								IDB_SETCLOCK);

			CClientDC	dc (this);							// Get a Client area DC

			memDC.CreateCompatibleDC (&dc);					// Create a clientarea compatible DC

			newMemBitmap			= new CBitmap;			// Instantiate a new Bitmap
			newMemBitmap->			CreateCompatibleBitmap (&dc, rect.Width(), rect.Height());
			
			CBitmap *pOldMemBitmap	= memDC.SelectObject (newMemBitmap);
			
			memDC.PatBlt			(0,0, FRAME_WIDTH, FRAME_HEIGHT, BLACKNESS);
			memDC.SelectObject		(pOldMemBitmap);		// Prevents memory leaks

			SetTimer	(IDT_TIMER1, TIMER_VALUE, NULL);	// Set timer for frame refresh

			Current_time= CTime::GetCurrentTime();			// Preload current time field

			button2->	EnableWindow(FALSE);				// Disable updates till query done
			
			font		= new CFont;						// Create a new font object

			}

CSetTimeWindow::~CSetTimeWindow()
			
			{
			if			(m_pWinSock)
						{
						delete		m_pWinSock;
						m_pWinSock	= NULL;
						}
			
			delete			button1;						// prevent memory leaks...
			delete			button2;
			b1->			DeleteObject(); delete b1;
			b2->			DeleteObject(); delete b2;
			delete			menu;
			delete			popupmenu;
			font->			DeleteObject(); delete font;
			newMemBitmap->	DeleteObject(); delete newMemBitmap;

			}

int			CSetTimeWindow::OnCreate(LPCREATESTRUCT lpCreateStruct)
			{
			if			(CFrameWnd::OnCreate(lpCreateStruct) == -1) return -1;

			if			(!m_wndStatusBar.Create(this) ||
						 !m_wndStatusBar.SetIndicators (indicators, sizeof(indicators)/sizeof (UINT)))
						{
						TRACE0("Failed to create status bar\n");
						return -1;
						}

			m_wndStatusBar.SetPaneInfo (0, m_wndStatusBar.GetItemID (0), SBPS_STRETCH, NULL);
			
			return 0;
			}

void		CSetTimeWindow::QueryTimebase()
			{

			button1->	EnableWindow(FALSE);
			button2->	EnableWindow(FALSE);

			m_pWinSock	= new CMyAsyncSocket();				// Instantiate a new Winsock object

			if			(m_pWinSock->Create(0, SOCK_STREAM, FD_CONNECT|FD_READ|FD_CLOSE))
						{
						m_wndStatusBar.SetPaneText (0, "Socket Created.", TRUE);
						m_wndStatusBar.SendMessage (WM_IDLEUPDATECMDUI);// Force an update to the Status Bar
						m_wndStatusBar.UpdateWindow();
						}
			else
						{
						m_wndStatusBar.SetPaneText (0, "Socket Creation FAILED!", TRUE);
						m_wndStatusBar.SendMessage (WM_IDLEUPDATECMDUI);
						m_wndStatusBar.UpdateWindow();

						delete		m_pWinSock;
						m_pWinSock	= NULL;

						button1->	EnableWindow(TRUE);		// Reset everything
						button2->	EnableWindow(TRUE);
						return;								// to allow retries
						}

			m_wndStatusBar.SetPaneText (0, "Connecting to Timebase...", TRUE);
			m_wndStatusBar.SendMessage (WM_IDLEUPDATECMDUI);// Force an update to the Status Bar
			m_wndStatusBar.UpdateWindow();

			char		TimeBase[50];						// Load TimeBase from Registry
			UINT		nHostPort = TIME_PROTOCOL_PORT;		// Internet Port Number

			lstrcpy		(TimeBase, (char *)(LPCTSTR) AfxGetApp()->GetProfileString ("Options","TimeBase"));
			
			m_pWinSock->Connect (TimeBase, nHostPort);		// Connect to current TimeBase
			}

void		CSetTimeWindow::UpdateSystemClock()
			{
			button2->	EnableWindow(FALSE);
			UpdateClock	= TRUE;
			QueryTimebase();
			}

void		MakeFont	(CFont *font, int x)
			{
			font->		DeleteObject();
			font->		CreateFont	(x, 0, 0, 0, FW_THIN, 0, 0, 0,
									ANSI_CHARSET, OUT_DEFAULT_PRECIS,
									CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY,
									DEFAULT_PITCH | TMPF_TRUETYPE, NULL);
			}

void		CSetTimeWindow::OnSize (UINT nType, int cx, int cy)
			{
			int			x = 2;
			CRect		r;
			CClientDC	dc (this);

			GetClientRect	(&rect);

			button1->		MoveWindow (CRect (rect.left, rect.top,	rect.right, rect.top+20));
			button2->		MoveWindow (CRect (rect.left, rect.bottom-40, rect.right, rect.bottom-20));

			rect.InflateRect(0, -20, 0, -40);				// Account for buttons in client area
			
			ShowControlBar	(&m_wndStatusBar, TRUE, FALSE);	// Show Status Bar in new location
			
			do
				{
				x			+= 10;							// try creating a font at size x
				r			= rect;							// calc size of string with that font

				MakeFont	(font, x);						// try a font on for size

				CFont *pOldFont	= memDC.SelectObject (font);// select the font onto DC
				
				memDC.DrawText	(Current_time.Format ("%X"),
									-1,
									r,
									DT_CALCRECT | DT_SINGLELINE | DT_CENTER | DT_VCENTER);

				memDC.SelectObject (pOldFont);				// prevent memory leaks

				} while			(rect == (r | rect));		// halt when string overflows the rect

			MakeFont			(font, x-10);				// Adjust final fontsize for 'drawface'

			GetClientRect		(&rect);
			
			newMemBitmap->		DeleteObject();
			newMemBitmap->		CreateCompatibleBitmap (&dc, rect.Width(), rect.Height());
			}

void		CSetTimeWindow::OnTimer (UINT id)
			{
			CClientDC	dc (this);
			DrawFace	(dc);
			
			if			(RunOnce == TRUE)					// If this is a one pass run
						{
						RunOnce = FALSE;					// Clear the run control flag
						UpdateSystemClock();				// Reset the System Clock
						ExitFlag = TRUE;					// And exit when convenient
						}
			}

void		CSetTimeWindow::OnPaint	()
			{
			CPaintDC	dc (this);
			DrawFace	(dc);
			}

void		CSetTimeWindow::OnExit()
			{
			DestroyWindow();
			}

void		CSetTimeWindow::OnAbout()
			{
			MessageBox	("RFC868 Time Protocol Client by pinter@p-squared.com", "About SetTime");
			}

void		CSetTimeWindow::OnTCPmode()
			{
/********	if	(TCPmode)
				{
				menu->		CheckMenuItem (IDM_TCP_MODE,	MF_BYCOMMAND|MF_UNCHECKED);
				popupmenu->	CheckMenuItem (IDM_TCP_MODE,	MF_BYCOMMAND|MF_UNCHECKED);
				menu->		CheckMenuItem (IDM_UDP_MODE,	MF_BYCOMMAND|MF_CHECKED);
				popupmenu->	CheckMenuItem (IDM_UDP_MODE,	MF_BYCOMMAND|MF_CHECKED);
				}
			else
				{
				menu->		CheckMenuItem (IDM_TCP_MODE,	MF_BYCOMMAND|MF_CHECKED);
				popupmenu->	CheckMenuItem (IDM_TCP_MODE,	MF_BYCOMMAND|MF_CHECKED);
				menu->		CheckMenuItem (IDM_UDP_MODE,	MF_BYCOMMAND|MF_UNCHECKED);
				popupmenu->	CheckMenuItem (IDM_UDP_MODE,	MF_BYCOMMAND|MF_UNCHECKED);
				}
			TCPmode	=!	TCPmode;********/					// toggle TCP mode flag
			}

void		CSetTimeWindow::OnRButtonDown (UINT x, CPoint p)
			{
			ClientToScreen (&p);							// convert client to screen coordinates
			tempmenu	= popupmenu->GetSubMenu (0);
			tempmenu->	TrackPopupMenu (TPM_CENTERALIGN|TPM_RIGHTBUTTON, p.x, p.y, this);
			}

void		CSetTimeWindow::OnTimeBase1 ()
			{
			Primary		= TRUE; Secondary = FALSE;			// Flag which Timebase in use
			AfxGetApp()-> WriteProfileString("Options",		// Save TimeBase in Registry
											 "TimeBase",
											 "tick.usno.navy.mil");
			m_wndStatusBar.SetPaneText (0, "tick.usno.navy.mil selected", TRUE);
			}

void		CSetTimeWindow::OnTimeBase2 ()
			{
			Primary		= FALSE; Secondary = TRUE;			// Flag which Timebase in use
			AfxGetApp()-> WriteProfileString("Options",		// Save TimeBase in Registry
											 "TimeBase",
											 "tock.usno.navy.mil");
			m_wndStatusBar.SetPaneText (0, "tock.usno.navy.mil selected", TRUE);
			}

void		CSetTimeWindow::OnTimeBase3 ()
			{
			CTimeBaseDialog	promptDialog (AfxGetApp()->GetProfileString ("Options","TimeBase"), this);

			if				(promptDialog.DoModal() == IDOK)
							{
							AfxGetApp()-> WriteProfileString("Options",
															 "TimeBase",
															 promptDialog.GetInputString());
							m_wndStatusBar.SetPaneText (0, "Alternate TimeBase Selected", TRUE);
							Primary		= FALSE;
							Secondary	= FALSE;		// Clear Timebase flags
							}
			}

void		CSetTimeWindow::OnUpdateStatusBar (CCmdUI *pCmdUI)
			{
			pCmdUI->	Enable (TRUE);
			}

void		CSetTimeWindow::OnUpdateTCP (CCmdUI *pCmdUI)
			{
			if	(TCPmode) 	pCmdUI->Enable (TRUE);
			else 			pCmdUI->Enable (FALSE);
			}

void		CSetTimeWindow::OnUpdateUDP (CCmdUI *pCmdUI)
			{
			if	(TCPmode) 	pCmdUI->Enable (FALSE);
			else 			pCmdUI->Enable (TRUE);
			}

void		CSetTimeWindow::OnUpdateTICK (CCmdUI *pCmdUI)
			{
			if	(Primary) 	pCmdUI->Enable (TRUE);
			else 			pCmdUI->Enable (FALSE);
			}

void		CSetTimeWindow::OnUpdateTOCK (CCmdUI *pCmdUI)
			{
			if	(Secondary) pCmdUI->Enable (TRUE);
			else 			pCmdUI->Enable (FALSE);
			}

void		CMyAsyncSocket::OnConnect (int nErrorCode)
			{
			CStatusBar	*pStatusBar = (CStatusBar *) AfxGetApp()->m_pMainWnd->GetDescendantWindow (ID_VIEW_STATUS_BAR);

			if			(!nErrorCode)
						{
						pStatusBar->SetPaneText (0, "Connected; waiting for Correct Time...", TRUE);
						pStatusBar->SendMessage (WM_IDLEUPDATECMDUI);// Force an update to the Status Bar
						pStatusBar->UpdateWindow();
						}
			else
						{
						pStatusBar->SetPaneText (0, "Connect FAILED. Verify Internet Link and/or TimeBase.", TRUE);
						pStatusBar->SendMessage (WM_IDLEUPDATECMDUI);// Force an update to the Status Bar
						pStatusBar->UpdateWindow();
						delete m_pWinSock;
						m_pWinSock = NULL;
						}
			}
void		CMyAsyncSocket::OnReceive (int nErrorCode)
			{
			time_t		New_time;							// Time value from Timebase
			CString		Delta;								// Contains delta time as a string
			CTimeSpan	Span;								// Holds delta time span of clocks
			SYSTEMTIME	Timecell;							// Holds System specific time value

			m_pWinSock->Receive (&New_time, sizeof(New_time));
			
			CStatusBar	*pStatusBar = (CStatusBar *) AfxGetApp()->m_pMainWnd->GetDescendantWindow (ID_VIEW_STATUS_BAR);
								
			if	(New_time == NULL)
				{
				pStatusBar->SetPaneText (0, "", TRUE);
				pStatusBar->SetPaneText (0, "Selected Timebase returned bogus data!", TRUE);
				pStatusBar->SendMessage (WM_IDLEUPDATECMDUI);// Force an update to the Status Bar
				pStatusBar->UpdateWindow();
				delete		m_pWinSock;
				m_pWinSock	= NULL;
				return;
				}

			New_time	= ntohl (New_time) - 2208988800;	// Offset to Jan 1, 1970

			Current_time= New_time;							// Store as a CTime object

			if	(UpdateClock)
				{
				UpdateClock				= FALSE;			// reset clock update flag
				Timecell.wYear			= Current_time.GetYear();
				Timecell.wMonth			= Current_time.GetMonth();
				Timecell.wDay			= Current_time.GetDay();
				Timecell.wHour			= Current_time.GetHour();
				Timecell.wMinute   		= Current_time.GetMinute();
				Timecell.wSecond		= Current_time.GetSecond();
				Timecell.wMilliseconds	= 0;
				SetLocalTime			(&Timecell);		// update system clock
				}

			Span	= CTime::GetCurrentTime() - Current_time;
			Delta	= Current_time.Format("Timebase Clock: %c. ") + Span.Format("Delta: %D days %H:%M:%S");

			pStatusBar->SetPaneText (0, Delta, TRUE);

			if		(abs(Span.GetTotalMinutes()) >= MAXIMUM_DELTA) AfxMessageBox (IDS_MAX_DELTA_WARNING, MB_OK);

			CButton	*Button1 = (CButton *) AfxGetApp()->m_pMainWnd->GetDescendantWindow (IDB_QUERY);
			CButton	*Button2 = (CButton *) AfxGetApp()->m_pMainWnd->GetDescendantWindow (IDB_SETCLOCK);

			Button1->	EnableWindow(TRUE);
			Button2->	EnableWindow(TRUE);

			if			(ExitFlag == TRUE)					// okay to bail?
						{
						ASSERT (AfxGetMainWnd() != NULL);
						AfxGetMainWnd()->PostMessage (WM_CLOSE);
						}
			return;
			}

void		CMyAsyncSocket::OnClose	(int nErrorCode)
			{
			if	(m_pWinSock)								// Not already deleted?
				{
				delete		m_pWinSock;
				m_pWinSock	= NULL;
				}
			}

void		CSetTimeWindow::DrawFace	(CDC &dc)
			{
			Current_time		= CTime::GetCurrentTime();	// Get current system time

			GetClientRect		(&rect);					// Get current client area size

			CFont	*pOldFont	= memDC.SelectObject (font);// Load calculated font into DC
			CBitmap *pOldBitMap	= memDC.SelectObject (newMemBitmap);

			memDC.FillSolidRect	(rect, BackGroundColour);	// Fill with background colour
			memDC.SetBkMode		(TRANSPARENT);				// Background Mode to Transparent
			memDC.SetTextColor	(ForeGroundColour);			// Set foreground text colour

			rect.InflateRect	(0, -20, 0, -40);			// Adjust for both buttons

			Okudagram			Backdrop;					// Create the Okudagram

			Backdrop.Paint		(memDC, rect);				// Paint in the graphics

			memDC.DrawText		(Current_time.Format ("%X"),// Write current time to screen
								-1,
								rect,
								DT_SINGLELINE |DT_CENTER | DT_VCENTER);

			dc.BitBlt			(0, 20, rect.Width(), rect.Height(),
								&memDC, 0, 20, SRCCOPY);	// Blast memory DC to screen

			memDC.SelectObject	(pOldFont);					// Prevent memory leaks
			memDC.SelectObject	(pOldBitMap);
			}

void		Okudagram::Paint (CDC &dc, CRect rect)
			{
			CPen	pen			(PS_SOLID, 2, RGB(255,0,0));
			CBrush	brush		(RGB(0,0,255));

			CPen	*pOldPen	= dc.SelectObject (&pen);
			CBrush	*pOldBrush	= dc.SelectObject (&brush);

			dc.RoundRect		(CRect (rect.left, rect.top,					rect.right, rect.bottom/10+rect.top),	CPoint (50,50));
			dc.RoundRect		(CRect (rect.left, rect.bottom-rect.bottom/10,	rect.right, rect.bottom),				CPoint (50,50));
			
			dc.SelectObject		(pOldPen);
			dc.SelectObject		(pOldBrush);
			}

void		CTimeBaseDialog::OnOK()
			{
			GetDlgItemText	(IDC_EDIT1, inputString.GetBuffer(100), 100);
			inputString.ReleaseBuffer();
			EndDialog		(IDOK);
			}

BOOL		CTimeBaseDialog::OnInitDialog()
			{
			SetDlgItemText	(IDC_EDIT1, inputString);
			return			TRUE;
			}
