/*****************************************************************/
/**               Microsoft Windows 4.00                        **/
/**           Copyright (C) Microsoft Corp., 1995-1996          **/
/*****************************************************************/

/* WPAPI.H -- WebPost Interface definitions
 *
 */

#ifdef __cplusplus
extern "C" {
#endif

typedef struct tagWPSITEINFO {
	DWORD	dwSize;
	DWORD	dwFlags;
	LPTSTR	lpszSiteName;
	LPTSTR	lpszSiteURL;
} WPSITEINFO, *LPWPSITEINFO;


// dwFlag for WpPost
#define WPF_NO_RECURSIVE_POST	0x00000001
#define WPF_NO_WIZARD			0x00000002
#define WPF_MINIMAL_UI			0x00000003

#ifdef UNICODE
DWORD WINAPI WpPostW(HWND hwnd, 
					DWORD cLocalPaths, LPWSTR *lppszLocalPaths, 
					LPDWORD lpcbSiteName, LPCWSTR lpszSiteName,
					LPDWORD lpcbURL, LPCWSTR lpszURL, 
					DWORD dwFlag);
DWORD WINAPI WpListSitesW(LPDWORD lpcbSites, LPWPSITEINFO lpSiteInfo,
							LPDWORD lpcSites);
DWORD WINAPI
WpBindToSiteW(
	HWND	hwnd,
	LPCWSTR	lpszSiteName,
	LPCWSTR	lpszURL,
	DWORD	dwFlag,
	DWORD	dwReserved,
    PVOID 	*ppvObj);

#else
DWORD WINAPI WpPostA(HWND hwnd,
					DWORD cLocalPaths, LPSTR *lppszLocalPaths, 
					LPDWORD lpcbSiteName, LPCSTR lpszSiteName,
					LPDWORD lpcbURL, LPCSTR lpszURL, 
					DWORD dwFlag);
DWORD WINAPI WpListSitesA(LPDWORD lpcbSites, LPWPSITEINFO lpSiteInfo,
							LPDWORD lpcSites);
DWORD WINAPI
WpBindToSiteA(
	HWND	hwnd,
	LPCSTR	lpszSiteName,
	LPCSTR	lpszURL,
	DWORD	dwFlag,
	DWORD	dwReserved,
    PVOID 	*ppvObj);

#endif


#ifdef UNICODE
#define WpPost					WpPostW
#define WpListSites				WpListSitesW
#define WpBindToSite			WpBindToSiteW

#else
#define WpPost					WpPostA
#define WpListSites				WpListSitesA
#define WpBindToSite			WpBindToSiteA

#endif


#ifdef __cplusplus
}
#endif
