/* ----------------------------------------------------------------------

	Copyright (c) 1995-1996, Microsoft Corporation
	All rights reserved

	dlg.c

	Dialogs

  ---------------------------------------------------------------------- */

#include "main.h"

#include "resource.h"
#define IDR_ADDR_FIRST     IDR_ADDR_UNKNOWN
#define IDR_ADDR_LAST      IDR_ADDR_ISDN

// Local dialog procs
LRESULT CALLBACK ConferenceDlgProc(HWND hdlg, UINT uMsg, WPARAM wparam, LPARAM lparam);



/*  D L G  C O N F E R E N C E  C O N N E C T */
/*----------------------------------------------------------------------------
    %%Function: DlgConferenceConnect
 
----------------------------------------------------------------------------*/
BOOL DlgConferenceConnect(VOID)
{
	ASSERT((IDR_ADDR_UNKNOWN - IDR_ADDR_FIRST) == CONF_ADDR_UNKNOWN);
	ASSERT((IDR_ADDR_IP - IDR_ADDR_FIRST) == CONF_ADDR_IP);
	ASSERT((IDR_ADDR_MACHINE - IDR_ADDR_FIRST) == CONF_ADDR_MACHINENAME);
	ASSERT((IDR_ADDR_PSTN - IDR_ADDR_FIRST) == CONF_ADDR_PSTN);

	return (0 == DialogBox(ghInst, MAKEINTRESOURCE(IDD_CONFERENCE),
		ghwndMain, (DLGPROC)ConferenceDlgProc));
}


/*  C O N F E R E N C E  D L G  P R O C */
/*----------------------------------------------------------------------------
    %%Function: ConferenceDlgProc
 
----------------------------------------------------------------------------*/
LRESULT CALLBACK ConferenceDlgProc(HWND hdlg, UINT uMsg, WPARAM wparam, LPARAM lparam)
{
	switch (uMsg)
	{
	case WM_INITDIALOG:
		CenterWindow(hdlg, ghwndMain);

		SetDlgItemText(hdlg, IDE_CONFNAME, gPref.szConferenceName);
		SetDlgItemText(hdlg, IDE_ADDR, gPref.szDefName);
		CheckRadioButton(hdlg, IDR_ADDR_FIRST, IDR_ADDR_LAST,
				IDR_ADDR_FIRST + gPref.iAddrType);

		{ // check media types
			int id;
			DWORD dwFlag = 0x01;
			for (id = IDC_MT_DATA; id <= IDC_MT_VIDEO; id++)
			{
				CheckDlgButton(hdlg, id, 0 != (gPref.dwMediaType & dwFlag));
				dwFlag <<= 1;
			}
		}

   		return fTrue;

	case WM_COMMAND:
		switch (GET_WM_COMMAND_ID(wparam, lparam))
		{
		case IDOK:
			gPref.iAddrType = GetRadioButton(hdlg, IDR_ADDR_FIRST, IDR_ADDR_LAST)
				- IDR_ADDR_FIRST;

			GetDlgItemText(hdlg, IDE_CONFNAME,
				gPref.szConferenceName, sizeof(gPref.szConferenceName));
			GetDlgItemText(hdlg, IDE_ADDR,
				gPref.szDefName, sizeof(gPref.szDefName));

			{ // check media types
				int id;
				DWORD dwFlag = 0x01;
				gPref.dwMediaType = 0;
				for (id = IDC_MT_DATA; id <= IDC_MT_VIDEO; id++)
				{
					if (IsDlgButtonChecked(hdlg, id))
						gPref.dwMediaType |= dwFlag;
					dwFlag <<= 1;
				}
			}

			EndDialog(hdlg, 0);
			return fTrue;

		case IDCANCEL:
			EndDialog(hdlg, 1);
			return fTrue;

		default:
			return fTrue;
		} /* switch (cmd) */

	default:
		break;
	} /* switch (uMsg) */

	return fFalse;
}

